package annotationexamples;

import java.lang.annotation.Annotation;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

public class FormProcessor {
    
    
    public FormProcessor() {
    }
    
    public void processForm(Object o) {
        for(Method m:o.getClass().getMethods()) {
            if(m.isAnnotationPresent(FormLabel.class) && m.getReturnType()==String.class) {
                FormLabel formLabel=m.getAnnotation(FormLabel.class);
                try {
                    String value=(String)m.invoke(o);
                    String label=formLabel.label();
                    int width=formLabel.width();
                    System.out.printf("%s[%d]:%s\n",label,width,value);
                } catch (IllegalArgumentException ex) {
                    ex.printStackTrace();
                } catch (IllegalAccessException ex) {
                    ex.printStackTrace();
                } catch (InvocationTargetException ex) {
                    ex.printStackTrace();
                }  
            }
        }
    }
}
